# Databricks notebook source
import json
import matplotlib.pyplot as plt
import numpy as np

import numpy as np
from scipy import interp
import matplotlib.pyplot as plt

from sklearn import svm, datasets
from sklearn.metrics import roc_curve, auc

# COMMAND ----------

def get_res(path):
  with open(path, 'r') as file:
    result = json.load(file)
    return result['true_positive_rates'], result['false_positive_rates'], result['thresholds'], result['auc_scores']

def get_pr_res(path):
  with open(path, 'r') as file:
    result = json.load(file)
    return result['precisions'], result['recalls'], result['pr_threshold']
  
def get_scores(path, column, fold, fault_type):
  with open(path, 'r') as file:
    result = json.load(file)
    return np.asarray(result['score_list_faults'][str(fault_type)][str(column)][str(fold)]), np.asarray(result['score_list_normal'][str(fault_type)][str(column)][str(fold)])
#get_scores(temp_paths[-1][0],6290,1,'typeIII')

# COMMAND ----------

dbutils.fs.ls('dbfs:/mnt/renewablesstudents/user-write/anomaly_scores/combined/')

# COMMAND ----------

columns = ['6290', '17712', '32028']

temp_paths = [
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/LSTM_AE_1d_v2.json', 'LSTM-AE'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/LSTM_AE_3d.json', 'LSTM-AE c'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/LSTM_predictions_50_1_v2.json', 'LSTM-p1'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/LSTM_predictions_50_3.json', 'LSTM-p3'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/LSTM_predictions_50_1_control.json', 'LSTM-p1 c'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/LSTM_predictions_50_3_control.json', 'LSTM-p3 c'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/LR_i50_o1.json', 'LR',)
]

temp_paths_IV = [
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/IV/LSTM_AE_1d.json', 'LSTM-AE'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/IV/LSTM_AE_3d.json', 'LSTM-AE c'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/IV/LSTM_predictions_i50_o1.json', 'LSTM-p1'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/IV/LSTM_predictions_i50_o3.json', 'LSTM-p3'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/IV/LSTM_predictions_i50_o1_c.json', 'LSTM-p1 c'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/IV/LSTM_predictions_i50_o3_c.json', 'LSTM-p3 c'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/IV/LR_i50_o1', 'LR'),
]

LR_paths = [
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/LR_i1_o1.json', 'LR1'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/LR_i5_o1.json','LR5'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/LR_i25_o1.json','LR25'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/LR_i50_o1.json','LR50'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/LR_i100_o1.json', 'LR100')
]

spat_paths = [
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/spatial/CAE4650.json', 'CAE4650'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/spatial/PCA_nc10.json','PCA10'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/spatial/PCA_nc25.json','PCA25'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/spatial/PCA_nc50.json','PCA50'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/spatial/PCA_nc100.json','PCA100'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/spatial/PCA_nc500.json', 'PCA500'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/spatial/PCA_nc1000.json', 'PCA1000'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/spatial/PCA_nc2000.json', 'PCA2000'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/spatial/PCA_nc4000.json', 'PCA4000')
]

comb_paths = [
 ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/spatial/PCA150_steps3_with_control.json', 'PCA150-3 c'),
 ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/spatial/PCA150_steps3_dts_only.json', 'PCA150-3'),
  ('/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/combined/LSTM101_PCA_nc100_weightedLoss_lr0_001.json', 'PCA-LSTM')
]

#Summing anomly likelihood score instead of max/average: '/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/spatial/CAE4650_score_summed.json'

# COMMAND ----------

LSTM_path = '/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/LSTM_predictions_50_1_col6290_fold1.json', 'LSTM-p'
LR_path = temp_paths[-1]
LR_path_IV = temp_paths_IV[-1]
LSTM_PATH_IV = temp_paths_IV[2]

CEA_path = spat_paths[0][0], 'CAE'
PCA_path = spat_paths[-3]

#fault_scores_lstm, norm_scores_lstm = get_scores(LSTM_path[0], 6290, 1, 'typeIII')

def plot_scores(path_name, fold=1, typeII='typeII'):
  path, name = path_name
  fault_scores, norm_scores = get_scores(path, 6290, fold, typeII)
  fault_scores_III, norm_scores_III = get_scores(path, 6290, fold, 'typeIV')
  
  plt.close()
  fig, axis = plt.subplots(1,2, sharey=True, figsize=(10,5))
  axis[0].scatter([i for i in range(len(norm_scores))], norm_scores, color='b', label='normal')
  axis[0].scatter([i for i in range(len(fault_scores))],fault_scores, color='r', alpha=0.7, label='fault')
  axis[1].scatter([i for i in range(len(norm_scores_III))], norm_scores_III, color='b')
  axis[1].scatter([i for i in range(len(fault_scores_III))],fault_scores_III, color='r', alpha=0.7)
  axis[0].set_title('Anomaly score for instant faults')
  axis[1].set_title('Anomaly score for gradual faults')
  axis[0].set_ylabel('Anomaly score')
  axis[0].set_xlabel('Fault index')
  axis[1].set_xlabel('Fault index') 
  axis[0].set_ylim(bottom=0)
  axis[1].set_ylim(bottom=0)
  axis[0].set_xlim(left=-3, right=len(fault_scores)+3)
  axis[1].set_xlim(left=-3, right=len(fault_scores_III)+3)
  plt.subplots_adjust(left=None, bottom=None, right=None, top=None, wspace=0.02, hspace=None)
  display(plt.show())
  
  return axis
  
plot_scores(CEA_path)  

# COMMAND ----------

PCA_path

# COMMAND ----------

axis = plot_scores(temp_paths_IV[0], typeII='typeIV')
#axis[1].axhline(400)
#axis[0].axhline(400)
#axis[0].set_ylim(top=2000)
#display(plt.show())

# COMMAND ----------


def plot_score(path_name, fold=1):
  path, name = path_name
  fault_scores, norm_scores = get_scores(path, 6290, fold, 'typeIV')
  
  plt.close()
  fig, axis = plt.subplots(1,1, sharey=True, figsize=(5,5))
  axis.scatter([i for i in range(len(norm_scores))], norm_scores, color='b', label='normal')
  axis.scatter([i for i in range(len(fault_scores))],fault_scores, color='r', alpha=0.7, label='fault')
  axis.set_title('Anomaly score for gradual faults for ' + name)
  axis.set_ylabel('Anomaly score')
  axis.set_xlabel('Fault index')
  axis.set_ylim(bottom=0)
  axis.set_xlim(left=-3, right=len(fault_scores)+3)
  plt.subplots_adjust(left=None, bottom=None, right=None, top=None, wspace=0.02, hspace=None)

  
  axis.axhline(207)
  axis.set_ylim(top=1000)
  
  display(plt.show())
  
  return axis
axis = plot_score(PCA_path)

# COMMAND ----------

CAE148_path = '/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/spatial/CAE148.json', 'CAE148'
#plot_scores(CAE148_path, fold='0')

# COMMAND ----------

#plot_scores(LR_paths[-1])

# COMMAND ----------

def compare_scores(path_name1, path_name2, fault_type):
  path1, name1 = path_name1
  path2, name2 = path_name2
  fault_scores1, norm_scores1 = get_scores(path1, 6290, 1, fault_type)
  fault_scores2, norm_scores2 = get_scores(path2, 6290, 1, fault_type)  
  
  #print('LR mean', 'fault', np.sort(fault_scores1), np.sort(norm_scores1), 'dist', np.mean(fault_scores1-norm_scores1))
  #print('LSTM mean', 'fault', np.sort(fault_scores2), np.sort(norm_scores2), 'dist', np.mean(fault_scores2- norm_scores2))
  
  print('sort',np.sort(norm_scores2))
  print('argsort', np.argsort(norm_scores2))
  
  #print(len(fault_scores1), len(fault_scores2))
  plt.close()
  fig, axis = plt.subplots(1,2, sharey=True, figsize=(9,4.5), sharex=True)
  axis[0].scatter([i for i in range(len(norm_scores1))], norm_scores1, color='b', label='normal')
  axis[0].scatter([i for i in range(len(fault_scores1))],fault_scores1, color='r', alpha=0.7, label='fault')
  axis[1].scatter([i for i in range(len(norm_scores2))], norm_scores2, color='b')
  axis[1].scatter([i for i in range(len(fault_scores2))],fault_scores2, color='r', alpha=0.7)
  fault_name = 'instant' if fault_type =='typeI' else 'gradual'
  axis[0].set_title(name1 + ' ' + fault_name + ' anomaly scores')
  axis[1].set_title(name2 + ' ' + fault_name + ' anomaly scores')
  axis[0].set_ylabel('Anomaly score')
  axis[0].set_xlabel('Fault id')
  axis[1].set_xlabel('Fault id')
  axis[0].set_ylim(bottom=0, top=1000)
  axis[0].set_xlim(left=-3, right=len(fault_scores1) + 3)
  axis[0].axvline(28, linestyle=':', color='green')
  axis[0].axvline(30,linestyle=':', color='green')
  axis[1].axvline(28, linestyle=':', color='green')
  axis[1].axvline(30,linestyle=':', color='green')
  plt.subplots_adjust(left=None, bottom=None, right=None, top=None, wspace=0.02, hspace=None)
  display(plt.show())
  
#compare_scores(LR_path, LSTM_path, 'typeI')  
compare_scores(LR_path_IV, LSTM_PATH_IV, 'typeIV')

# COMMAND ----------

LSTM_control_path = '/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/LSTM_predictions_50_1_CONTROL_col6290_fold1.json', 'LSTM-p c'
compare_scores(LSTM_control_path, LSTM_path, 'typeI')  

# COMMAND ----------

compare_scores(LR_path, LSTM_path, 'typeIII')  

# COMMAND ----------

compare_scores(LR_paths[0], LR_paths[-1], 'typeI')

# COMMAND ----------

def ROC_plot_average_intervals(path_name, fault_type = 'typeII', plot_individual=True, clear_plot=True, plot_std=True, count=0, multiple_plots=False, legend=True):
  assert fault_type != 'typeIII'
  if fault_type == 'typeI':
    print('WARNING: Fault type is I')
  path, name = path_name
  tpr_dir, fpr_dir, _, AUCs_dir = get_res(path)
  folds = [0,1,2,3,4]
  if clear_plot:
    plt.close()
    plt.figure(figsize=(6,5))
  tprs = []
  aucs = []
  mean_fpr = np.linspace(0, 1, 100)
  for column in columns:
      for fold in folds:
        fpr = fpr_dir[fault_type][str(column)][str(fold)]
        tpr = tpr_dir[fault_type][str(column)][str(fold)]
        tprs.append(interp(mean_fpr, fpr, tpr))
        tprs[-1][0] = 0.0
        roc_auc = AUCs_dir[fault_type][str(column)][str(fold)]
        aucs.append(roc_auc)
        if plot_individual:
          plt.plot(fpr, tpr, lw=1, alpha=0.3,
               #label='ROC c:{} f:{} (AUC={:.2f})'.format(column, fold+1, roc_auc)
                )
  if not count:
    plt.plot([0, 1], [0, 1], linestyle='--', lw=2, color='black',
           label='Chance', alpha=.8)
  mean_tpr = np.mean(tprs, axis=0)
  mean_tpr[-1] = 1.0
  mean_auc = auc(mean_fpr, mean_tpr)
  std_auc = np.std(aucs)
  label = 'Mean ROC' if not multiple_plots else name #+ ' mean ROC'  # (AUC = %0.3f $\pm$ %0.3f)' % (mean_auc, std_auc),
  plt.plot(mean_fpr, mean_tpr, color='b' if not multiple_plots else None,
           label=label, 
           lw=2, alpha=.8)
  std_tpr = np.std(tprs, axis=0)
  tprs_upper = np.minimum(mean_tpr + std_tpr, 1)
  tprs_lower = np.maximum(mean_tpr - std_tpr, 0)
  if plot_std:
    plt.fill_between(mean_fpr, tprs_lower, tprs_upper, color='grey', alpha=.2,
                   label=r'$\pm$ 1 std. dev.' if not multiple_plots else None)
  plt.xlim([-0.05, 1.05])
  plt.ylim([-0.05, 1.05])
  plt.xlabel('False Positive Rate')
  plt.ylabel('True Positive Rate')
  if multiple_plots: plt.title('Mean ROC {} faults'.format('instant' if fault_type in ['typeI', 'typeII'] else 'gradual'))
  else: plt.title('Mean ROC for ' + name)
  if legend:
    plt.legend(loc="lower right", fontsize='small')
  display(plt.show())

# COMMAND ----------

#ROC_plot_average_intervals(temp_paths_IV[0], fault_type='typeIV')

# COMMAND ----------

#ROC_plot_average_intervals(temp_paths[0], fault_type='typeIII')

# COMMAND ----------

plt.close()
plt.figure(figsize=(5,4.5))
for count, path_and_name in enumerate(comb_paths):
  ROC_plot_average_intervals(path_and_name, plot_individual=False, clear_plot=False, count=count, plot_std=False, fault_type='typeII', multiple_plots=True, legend=True)

# COMMAND ----------

plt.close()
plt.figure(figsize=(5,4.5))
for count, path_and_name in enumerate(temp_paths_IV):
  ROC_plot_average_intervals(path_and_name, plot_individual=False, clear_plot=False, count=count, plot_std=False, fault_type='typeIV', multiple_plots=True, legend=False)

# COMMAND ----------

def avg_auc_scores(path_name, fault_types, print_R=True):
  path, name = path_name
  #print(fault_types)
  _, _, _, AUCs_dir = get_res(path)
  auc_scores = {ft:[] for ft in fault_types}
  for fault_type in fault_types:
    #print(fault_type)
    s = 'c('
    for column in columns:#sorted(AUCs_dir[fault_type].keys(), key=int):
      for fold in sorted(AUCs_dir[fault_type][column].keys(), key=int):
        auc_score = AUCs_dir[fault_type][column][fold]
        auc_scores[fault_type].append(auc_score)
        s += str(auc_score) + ', '
    s = s[:-2] + ')'
    if len(auc_scores[fault_type]) < 15:
      print('only {} auc scores in mean'.format(len(auc_scores)))
    if print_R:
      fault_name = 'gradual' if fault_type == 'typeIV' else 'instant'
      
      print(name.replace(' ', '_').replace('-', '_') +'_'+ fault_name + ' = ' + s)
  if not print_R:
    s = name
    for key in sorted(auc_scores.keys()):
      #print('key', key)
      s += ' & {}'.format(np.mean(auc_scores[key]))
    print(s + ' \\\ \hline')

# COMMAND ----------

for tp_name in spat_paths:
  avg_auc_scores(tp_name, ['typeII', 'typeIV'], print_R=False)

# COMMAND ----------

for ft in ['typeI']:
  print('#'+ft+', temporal, AUCs')
  for tp_name in temp_paths:
    avg_auc_scores(tp_name, [ft], print_R=True)
  print()



# COMMAND ----------

for ft in ['typeII','typeIV']:
  print('#'+ft+', spatial, AUCs')
  for tp_name in spat_paths:
    avg_auc_scores(tp_name, [ft], print_R=True)
  print()

# COMMAND ----------

for tp_name in temp_paths:
  avg_auc_scores(tp_name, ['typeIII'], print_R=True)

# COMMAND ----------

seqs = [
  [0.052,0.073,0.041,0.054,0.045],
  [0.052,0.075,0.035,0.055,0.050],
  [0.050,0.073,0.033,0.052,0.041],
  [0.051,0.072,0.036,0.053,0.042],
  [0.054,0.081,0.034,0.054,0.046],
  [0.051,0.074,0.037,0.054,0.041],
  [0.055,0.078,0.033,0.056,0.043]
      ]

for seq in seqs:
  print(np.mean(seq))

# COMMAND ----------


