# Databricks notebook source
from sklearn.decomposition import PCA
import tensorflow as tf
import tensorflow.contrib.rnn as rnn_cell

# COMMAND ----------

# MAGIC %run ./func_spatiotemporal

# COMMAND ----------

# MAGIC %run ../temporal/func_AD_evaluation

# COMMAND ----------

# Models:

#Not weighgted:
#  Logs:   /dbfs/mnt/renewablesstudents/user-write/logfiles/p2/spatiotemporal_model/PCA_LSTM_MSE_notWeighted.txt
#  Models: /dbfs/mnt/renewablesstudents/user-write/models/p2/spatiotemporal_model/PCA_LSTM_MSE_notWeighted/params_t{}v{}/model.ckpt

#Weighted
#  Logs:  /dbfs/mnt/renewablesstudents/user-write/logfiles/p2/spatiotemporal_model/PCA_LSTM_weightedLoss.txt
#  Models: /dbfs/mnt/renewablesstudents/user-write/models/p2/spatiotemporal_model/PCA_LSTM_weightedLoss/params_t{}v{}/model.ckpt

#  Logs: /dbfs/mnt/renewablesstudents/user-write/logfiles/p2/spatiotemporal_model/PCA_LSTM_weightedLoss_lr0_001.txt
# Models: /dbfs/mnt/renewablesstudents/user-write/models/p2/spatiotemporal_model/PCA_LSTM_weightedLoss_lr0_001/params_t{}v{}/model.ckpt

# COMMAND ----------

SUBSET = False
sp_SUBSET = False

OUTPUT_STEPS = 1
INPUT_STEPS = 10
PCA_COMPONENTS = 100

fold_ranges = get_fold_ranges(subset=SUBSET)  

df_dts = load_DTS_data(subset=SUBSET)  # First 39516 columns segments, last 3 columns 'timestamp', 'new_timestamp', 'sampling_interval'
df_current = load_current_data(subset=SUBSET)
df_seatemp = load_seatemp_data(subset=SUBSET)
df_dts_joined = join_dts_curr_seatemp(df_dts, df_current, df_seatemp)

assert len(list(df_dts)) == n_segments + 3 and list(df_dts)[-3:] == ['timestamp', 'new_timestamp', 'sampling_interval']
if sp_SUBSET:
  df_dts = df_dts.iloc[:, -103:]
  n_segments = 100

df_dts.shape, df_dts_joined.shape

# COMMAND ----------

# TOdo run for 3 suffixes.
df_segment, segment = None, None
model_suffix= '_weightedLoss_lr0_001'
model_dir = '/dbfs/mnt/renewablesstudents/user-write/models/p2/spatiotemporal_model/PCA_LSTM' + model_suffix + '/params_t{}v{}/model.ckpt'
train_op, p, x, t, y, w = ST_model(log=Log(), n_hidden=1000)
saver = tf.train.Saver()
res = get_all_anomaly_scores(LSTM_PCA_PredictionsAnomalyDetector, model_dir, fault_dir, fault_types =['typeI', 'typeII', 'typeIII', 'typeIV'], columns = [6290, 17712, 32028, 'random'],
                               save_path='/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/combined/LSTM{}{}_PCA_nc{}{}.json'.format(INPUT_STEPS, OUTPUT_STEPS, PCA_COMPONENTS, model_suffix))



# COMMAND ----------

# TOdo run for 3 suffixes.
df_segment, segment = None, None
model_suffix= 'PCA_LSTM_MSE_notWeighted'
model_dir = '/dbfs/mnt/renewablesstudents/user-write/models/p2/spatiotemporal_model/PCA_LSTM' + model_suffix + '/params_t{}v{}/model.ckpt'
train_op, p, x, t, y, w = ST_model(log=Log(), n_hidden=1000)
saver = tf.train.Saver()
res = get_all_anomaly_scores(LSTM_PCA_PredictionsAnomalyDetector, model_dir, fault_dir, fault_types =['typeI', 'typeII', 'typeIII', 'typeIV'], columns = [6290, 17712, 32028],
                               save_path='/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/combined/LSTM{}{}_PCA_nc{}{}.json'.format(INPUT_STEPS, OUTPUT_STEPS, PCA_COMPONENTS, model_suffix))

# TOdo run for 3 suffixes.
df_segment, segment = None, None
model_suffix= 'PCA_LSTM_weightedLoss'
model_dir = '/dbfs/mnt/renewablesstudents/user-write/models/p2/spatiotemporal_model/PCA_LSTM' + model_suffix + '/params_t{}v{}/model.ckpt'
train_op, p, x, t, y, w = ST_model(log=Log(), n_hidden=1000)
saver = tf.train.Saver()
res = get_all_anomaly_scores(LSTM_PCA_PredictionsAnomalyDetector, model_dir, fault_dir, fault_types =['typeI', 'typeII', 'typeIII', 'typeIV'], columns = [6290, 17712, 32028],
                               save_path='/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/combined/LSTM{}{}_PCA_nc{}{}.json'.format(INPUT_STEPS, OUTPUT_STEPS, PCA_COMPONENTS, model_suffix))

# COMMAND ----------

result = json.loads(res)

tpr = result['true_positive_rates']['typeI']['random']['1']
fpr = result['false_positive_rates']['typeI']['random']['1']

plt.close()
plt.plot(fpr, tpr)
plt.xlim([-0.05, 1.05])
plt.ylim([-0.05, 1.05])
display(plt.show())

# COMMAND ----------

quantile = 0.999

for column in []: # [6290, 17712, 32028]:
  log =  Log('/dbfs/mnt/renewablesstudents/user-write/models/p2/evaluation/column_{}'.format(column), '/PCA{}_LSTM{}_{}_weighted_lr0_001'.format(PCA_COMPONENTS, INPUT_STEPS, OUTPUT_STEPS))
  models_dir = '/dbfs/mnt/renewablesstudents/user-write/models/p2/spatiotemporal_model/PCA_LSTM_weightedLoss_lr0_001/params_t{}v{}/model.ckpt'
  log.write('models_dir: ' + models_dir)
  log.write('quantile: {}'.format(quantile))
  
  train_op, p, x, t, y, w = ST_model(log=log, n_hidden=1000)
  saver = tf.train.Saver()
  ad = LSTM_PCA_PredictionsAnomalyDetector(models_dir, quantile)
  
  df_segment, segment  = load_segment_data(subset=SUBSET, column=column)
  _ = get_AD_results_V2(ad, fault_dir, column=column, log=log)

# COMMAND ----------

#dbutils.fs.ls('dbfs:/mnt/renewablesstudents/user-write/models/p2/evaluation')
