# Databricks notebook source
from sklearn.decomposition import PCA
import tensorflow as tf
import tensorflow.contrib.rnn as rnn_cell

# COMMAND ----------

# MAGIC %run ./func_spatiotemporal

# COMMAND ----------

SUBSET = False
sp_SUBSET = False

fold_ranges = get_fold_ranges(subset=SUBSET)  
df_dts = load_DTS_data(subset=SUBSET)  # First 39516 columns segments, last 3 columns 'timestamp', 'new_timestamp', 'sampling_interval'
df_current = load_current_data(subset=SUBSET)
df_seatemp = load_seatemp_data(subset=SUBSET)

assert len(list(df_dts)) == n_segments + 3 and list(df_dts)[-3:] == ['timestamp', 'new_timestamp', 'sampling_interval']
if sp_SUBSET:
  df_dts = df_dts.iloc[:, -103:]
  n_segments = 100
  
df_joined = join_dts_curr_seatemp(df_dts, df_current, df_seatemp)
df_dts.shape, df_joined.shape

# COMMAND ----------

OUTPUT_STEPS = 1
INPUT_STEPS = 10
PCA_COMPONENTS = 100

# COMMAND ----------

#data_generator = Spatiotemporal_data_by_fold_PCA(0, 1, fold_ranges)
#print('generator constructed')
#train_inputs, train_targets, train_intervals = data_generator.get_training_data()
#val_inputs, val_targets, val_intervals = data_generator.get_validation_data()
#val_inputs.shape, val_targets.shape, val_intervals.shape

#val_inputs_segments, val_targets_segments, val_intervals_segments = data_generator.get_validation_data_not_PCA()
#train_inputs_segments, train_targets_segments, train_intervals_segments = data_generator.get_training_data_not_PCA()
#val_inputs_segments.shape, val_targets_segments.shape, val_intervals_segments.shape

# COMMAND ----------

# 
#save_model

logs_dir, models_dir = set_dirs('spatiotemporal_model')
file_suffix ='PCA_LSTM_weightedLoss_lr0_001'
n_epochs = 1000

log = Log(logs_dir, file_suffix)
if log: log.write('setup: (' + 'SUBSET: '+str(SUBSET) + ', OUTPUT_STEPS: '+str(OUTPUT_STEPS)+ ', INPUT_STEPS: '+ str(INPUT_STEPS)+ ', PCA_COMPONENTS: '+ str(PCA_COMPONENTS) +')')
train_op, p, x, t, y, w = ST_model(log=log, n_hidden=1000, lr=0.001)
saver = tf.train.Saver()
val_preds, train_preds = None, None
val_preds, train_preds = trainPCA_PredictionNetwork(log=log,
                                                batch_size=128,
                                                n_epochs=n_epochs,
                                                initial_patience=100,
                                                all_test_folds=True,
                                                file_suffix=file_suffix,
                                                save_model=True,
                                                use_loss_weights=True
                                                )
print('-------------------------------------------------------------------------\n\n')

# COMMAND ----------

params_path = '/dbfs/mnt/renewablesstudents/user-write/models/p2/spatiotemporal_model/test/test_{}/params_t0v1/model.ckpt'.format(len(os.listdir(logs_dir)) -1)
with tf.Session() as sess:
  saver.restore(sess, params_path)
  val_preds = get_predictions(sess, val_inputs, val_intervals)
  train_preds = get_predictions(sess, train_inputs, train_intervals)

# COMMAND ----------

def cable_from_pca(pca_data):
  pca_data = pca_data.copy()
  pca_data = pca_data * data_generator.encoding_std + data_generator.encoding_mean
  seg = pca_data @ data_generator.PCA.components_
  return seg
#val_targets

# COMMAND ----------

def plot_recs(inputs, targets, preds, input_segments, target_segments, index=0):
  assert targets.shape == preds.shape
  target_cable = target_segments
  pred_cable = cable_from_pca(preds)
  inp = input_segments[:,-1,:-3]

  plt.close()
  fig, (ax1, ax2, ax3) = plt.subplots(3,1)
  #ax0.plot(targets[index], color='b')
  ax1.plot(inputs[index,-1,:-3], color='green')
  #ax0.set_ylabel('target and prev step')
  ax1.plot(preds[index], color='r')
  ax1.plot(targets[index], color='b')
  ax1.set_ylabel('target and pred')
  #ax2.plot(inp[index,:], color='green')
  ax2.plot(target_cable[index,:], color='b')
  ax2.plot(pred_cable[index,:], color='r')
  ax3.plot(target_cable[index,:200], color='b')
  ax3.plot(pred_cable[index,:200], color='r')
  display(plt.show())

# COMMAND ----------

plot_recs(val_inputs, val_targets, val_preds, val_inputs_segments, val_targets_segments, index=2000)

# COMMAND ----------

plot_recs(train_inputs, train_targets, train_preds, train_inputs_segments, train_targets_segments)

# COMMAND ----------


