# Databricks notebook source
import tensorflow as tf
import tensorflow.nn.rnn_cell as rnn_cell

# COMMAND ----------

# MAGIC %run ./func_temporal

# COMMAND ----------

# MAGIC %run ./func_AD_evaluation

# COMMAND ----------

# Temporal LSTM autoencoder models

#1d
#  logs: /dbfs/mnt/renewablesstudents/user-write/logfiles/p2/temporal_model/column_6290/LSTM_autoencoder/AE_1d.txt  # 1st column (6290)
#  logs: /dbfs/mnt/renewablesstudents/user-write/logfiles/p2/temporal_model/column_{}/LSTM_autoencoder/AE_1d_v2.txt  # cols 17712, 32028
#  params: /dbfs/mnt/renewablesstudents/user-write/models/p2/temporal_model/column_{}/LSTM_autoencoder/AE_1d/params_t{}v{}/model.ckpt

#3d
#  logs: /dbfs/mnt/renewablesstudents/user-write/logfiles/p2/temporal_model/column_{}/LSTM_autoencoder/AE_3d.txt
#  params: /dbfs/mnt/renewablesstudents/user-write/models/p2/temporal_model/column_{}/LSTM_autoencoder/AE_3d/params_t{}v{}/model.ckpt

# COMMAND ----------

SUBSET = False
WINDOW_SIZE = 50
ONLY_SEGMENT = True

fold_ranges = get_fold_ranges(subset=SUBSET)
df_current  = load_current_data(subset=SUBSET)
df_seatemp  = load_seatemp_data(subset=SUBSET)

df_dts = load_DTS_data(subset=SUBSET)  # First 39516 columns segments, last 3 columns 'timestamp', 'new_timestamp', 'sampling_interval'
assert len(list(df_dts)) == n_segments + 3 and list(df_dts)[-3:] == ['timestamp', 'new_timestamp', 'sampling_interval']



# COMMAND ----------

# ROC curve and AUC score
ONLY_SEGMENT = True
train_op, r, x, bs, loss_op = LSTM_autoencoder_graph(lr=-1)
saver = tf.train.Saver()
models_dir = '/dbfs/mnt/renewablesstudents/user-write/models/p2/temporal_model/column_{}/LSTM_autoencoder/AE_1d/params_t{}v{}/model.ckpt'
df_segment, segment  = None, None

res = get_all_anomaly_scores(LSTM_AE_AnomalyDetector, models_dir, fault_dir, fault_types=['typeIV'],
                             save_path='/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/IV/LSTM_AE_1d.json')

# COMMAND ----------

result = json.loads(res)

tpr = result['true_positive_rates']['typeIV']['6290']['0']
fpr = result['false_positive_rates']['typeIV']['6290']['0']

plt.close()
plt.plot(fpr, tpr)
plt.xlim([-0.05, 1.05])
plt.ylim([-0.05, 1.05])
display(plt.show())

# COMMAND ----------

# ROC curve and AUC score
ONLY_SEGMENT = False
train_op, r, x, bs, loss_op = LSTM_autoencoder_graph(lr=-1)
saver = tf.train.Saver()

models_dir = '/dbfs/mnt/renewablesstudents/user-write/models/p2/temporal_model/column_{}/LSTM_autoencoder/AE_3d/params_t{}v{}/model.ckpt'
df_segment, segment  = None, None

res = get_all_anomaly_scores(LSTM_AE_AnomalyDetector, models_dir, fault_dir, fault_types=['typeIV'],
                             save_path='/dbfs/mnt/renewablesstudents/user-write/anomaly_scores/temporal/IV/LSTM_AE_3d.json')

# COMMAND ----------

result = json.loads(res)

tpr = result['true_positive_rates']['typeIV']['6290']['0']
fpr = result['false_positive_rates']['typeIV']['6290']['0']

plt.close()
plt.plot(fpr, tpr)
plt.xlim([-0.05, 1.05])
plt.ylim([-0.05, 1.05])
display(plt.show())

# COMMAND ----------

#Precision, recall etc.
for column in []: #[6290, 17712, 32028]:
  models_dir = '/dbfs/mnt/renewablesstudents/user-write/models/p2/temporal_model/column_{}/'.format(column) + 'LSTM_autoencoder/AE_1d/params_t{}v{}/model.ckpt'
  log =  Log() #Log('/dbfs/mnt/renewablesstudents/user-write/models/p2/evaluation/column_{}'.format(column), '/LSTM_AE_{}d_999quantile'.format(1 if ONLY_SEGMENT else 3))
  df_segment, segment  = load_segment_data(subset=SUBSET, column=column)
  df_joined = join_temp_curr_seatemp(df_segment, df_current, df_seatemp)
  q = 0.999
  log.write('quantile: {}'.format(q))
  ad = LSTM_AE_AnomalyDetector(models_dir, quantile=q)
  ad_results = get_AD_results_V2(ad, fault_dir, column=column, log=log)

