# Databricks notebook source
# MAGIC %run ./func_temporal

# COMMAND ----------

SUBSET = False
segment_columns = [17712, 32028]
ONLY_SEGMENT = True

fold_ranges = get_fold_ranges(subset=SUBSET)  
df_current = load_current_data(subset=SUBSET)
df_seatemp = load_seatemp_data(subset=SUBSET)

print(df_current.new_timestamp.iloc[-1],  df_seatemp.new_timestamp.iloc[-1])

# COMMAND ----------

for column_index in range(len(segment_columns)):
  df_segment, segment = load_segment_data(segment_columns[column_index], subset=SUBSET)
  df_joined = join_temp_curr_seatemp(df_segment, df_current, df_seatemp)
  print('segment', segment, 'column', segment_columns[column_index])

  logs_dir, models_dir = set_dirs('temporal_model/column_{}/LSTM_autoencoder'.format(segment_columns[column_index]))
  file_suffix = 'AE_{}d_v2'.format(1 if ONLY_SEGMENT else 3)
  n_epochs = 2000

  log = Log(logs_dir, file_suffix)
  train_op, r, x, bs, loss_op = LSTM_autoencoder_graph(lr=0.001, log=log)
  saver = tf.train.Saver()
  val_preds = train_AE_network(log=log, n_epochs=n_epochs, all_test_folds=True, file_suffix=file_suffix, data_by_fold=Temporal_Autoencoder_data_by_fold)
  
  print('-------------------------------------------------------------------------\n\n')

# COMMAND ----------

#params_path = '/dbfs/mnt/renewablesstudents/user-write/models/p2/temporal_model/column_6290/LSTM_autoencoder/test_both50/params_t0v1/model.ckpt'
preds = get_recs_from_saved_params(params_path, targets)
preds.shape

# COMMAND ----------

with open('/dbfs/mnt/renewablesstudents/user-write/logfiles/p2/temporal_model/column_6290/LSTM_autoencoder/AE_1d.txt', 'r') as file:
  for line in file:
    print(line)

# COMMAND ----------


