# Databricks notebook source
import tensorflow as tf
import tensorflow.contrib.rnn as rnn_cell

# COMMAND ----------

# MAGIC %run ./func_temporal

# COMMAND ----------

SUBSET = False
segment_columns = [6290, 17712, 32028]
OUTPUT_STEPS = 3
PREDICT_CONTROL = True

fold_ranges = get_fold_ranges(subset=SUBSET)  
df_current = load_current_data(subset=SUBSET)
df_seatemp = load_seatemp_data(subset=SUBSET)

print(df_current.new_timestamp.iloc[-1], df_seatemp.new_timestamp.iloc[-1])

# COMMAND ----------

def plot_joined_df():
  plt.close()
  fig, axis = plt.subplots(4,1)
  axis[0].plot(df_joined[segment])
  axis[1].plot(df_joined['current'])
  axis[2].plot(df_joined['sea_temp'])
  axis[3].plot(df_joined['sampling_int'])

  display(plt.show())
#plot_joined_df()

# COMMAND ----------

for column_index in range(len(segment_columns)):
  df_segment, segment = load_segment_data(segment_columns[column_index], subset=SUBSET)
  df_joined = join_temp_curr_seatemp(df_segment, df_current, df_seatemp)
  print('segment', segment, 'column', segment_columns[column_index])

  logs_dir, models_dir = set_dirs('temporal_model/LSTM_prediction/column_{}/'.format(segment_columns[column_index]))
  file_suffix = 'LSTM_predictions_with_control_os{}'.format(OUTPUT_STEPS)
  n_epochs = 1000

  log = Log(logs_dir, file_suffix)
  train_op, p, x, t, y = LSTM_prediction_graph(n_hidden=128, log=log, n_output_steps=OUTPUT_STEPS, predict_control=True)
  
  saver = tf.train.Saver()
  if PREDICT_CONTROL:
    val_preds, train_preds = trainPredictionNetwork(log=log,
                                                    n_epochs=n_epochs,
                                                    all_test_folds=True,
                                                    file_suffix=file_suffix,
                                                    dbf=Temporal_prediction_data_by_fold_with_control if PREDICT_CONTROL else Temporal_prediction_data_by_fold)
  
  print('-------------------------------------------------------------------------\n\n')

# COMMAND ----------


